Index: channels/chan_misdn.c
===================================================================
--- channels/chan_misdn.c	(revision 89320)
+++ channels/chan_misdn.c	(working copy)
@@ -3437,6 +3437,7 @@
 {
 	int chan_offset = 0;
 	int tmp_port = misdn_cfg_get_next_port(0);
+	char newname[255];
 	for (; tmp_port > 0; tmp_port = misdn_cfg_get_next_port(tmp_port)) {
 		if (tmp_port == port)
 			break;
@@ -3445,10 +3446,12 @@
 	if (c < 0)
 		c = 0;
 
-	ast_string_field_build(tmp, name, "%s/%d-u%d",
-				 misdn_type, chan_offset+c, glob_channel++);
-
-	chan_misdn_log(3 , port, " --> updating channel name to [%s]\n", tmp->name);
+	snprintf(newname,sizeof(newname),"%s/%d-",misdn_type,chan_offset+c);
+	if (strncmp(tmp->name,newname,strlen(newname))) {
+		snprintf(newname,sizeof(newname),"%s/%d-u%d", misdn_type, chan_offset+c, glob_channel++);
+		ast_change_name(tmp,newname);
+		chan_misdn_log(3,port," --> updating channel name to [%s]\n",tmp->name);
+	}
 }
 
 static struct ast_channel *misdn_new(struct chan_list *chlist, int state,  char *exten, char *callerid, int format, int port, int c)
@@ -3470,7 +3473,10 @@
 	if (callerid) 
 		ast_callerid_parse(callerid, &cid_name, &cid_num);
 
-	tmp = ast_channel_alloc(1, state, cid_num, cid_name, "", exten, "", 0, "%s/%d-u%d", misdn_type, chan_offset + c, glob_channel++);
+	if (c)
+		tmp = ast_channel_alloc(1, state, cid_num, cid_name, "", exten, "", 0, "%s/%d-u%d", misdn_type, chan_offset + c, glob_channel++);
+	else
+		tmp = ast_channel_alloc(1, state, cid_num, cid_name, "", exten, "", 0, "%s/tmp%d-u%d", misdn_type, chan_offset + c, glob_channel++);
 
 	if (tmp) {
 		chan_misdn_log(2, 0, " --> * NEW CHANNEL dad:%s oad:%s\n", exten, callerid);
